import 'package:flutter/material.dart';
import 'package:materialdesignlogo/assets/strings.dart';
import 'package:materialdesignlogo/widget_type.dart';
import 'package:materialdesignlogo/materialdesignlogo.dart';

List<Widget>autoTextScreen(){
  var autoTexts = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
  return [
    VSpace(30   ),
    Center(
      child: Container(
        width: 230,
        child: MdiLogo.autoShapeText(
          text: autoTexts,
          borderWidth: {autoTexts: 1},
          shapeShadow: {
            autoTexts: ShadowAsset.singleShadow(
                shadowColor: Colors.grey[600], dx: -2, dy: 1.6)
          },
          letterSpacing: {'ABJFN': 4.0},
          logoShape: {
            'R': BoxShape.circle,
          },
          shapeColor: {
            'LANRE': Colors.deepPurpleAccent,
          },
          fontSize: {'ASDF': 24, 'LKJ': 35},
        ),
      ),
    ),];
}
List<Widget> combinedWidgets() {
  var autoTexts = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
  var autoText2 = 'BBC';
  return [
    VSpace(),
    Center(
      child: Container(
          width: 230,
          child: MdiLogo.autoShapeText(
            text: autoText2,
//            borderWidth: {autoText2: 0.5},
            fontSize: {0: 74.0, },
          )),
    ),
    VSpace(),
    MdiLogo.android(),
    VSpace(),
    MdiLogo.microsoftXBox(),
    VSpace(),
    MdiLogo.microsoftCombined(),
    VSpace(),
    MdiLogo.adobe(),
    VSpace(20),
    buildCombinedLogo(
        mainTextDecoration: TextDecoration.none,
        leadText: 'LOVELY',
        mainText: 'GAME'),
    VSpace(20),
    buildCombinedLogo(
        gap: 0,
        shapeColor: Colors.red,
        mainTextStyle: TextDecorationStyle.wavy,
//        mainTextDecoration: TextDecoration.none,
        mainTextPaddingTop: 0.0,
        leadText: 'ANDROID',
        leadGravity: LeadGravity.top),
    VSpace(),
    MdiLogo.linkedlnCombine(),
    MdiLogo.instagramCombine(),
  ];
}

Widget buildCombinedLogo(
    {mainTextDecoration,
    leadText: "MARVAL",
    mainTextStyle: TextDecorationStyle.wavy,
    shapeColor: Colors.teal,
    mainText: "STUDIO",
    mainTextPaddingTop: 8.0,
    mainTextSize: 25,
    leadGravity: LeadGravity.start,
    gap: 5.0}) {
  return MdiLogo.combinedLogo(
    leadGravity: leadGravity,
    gap: gap,
    content: Padding(
      padding: EdgeInsets.only(top: mainTextPaddingTop),
      child: MdiLogo.combinePlainTextSample(
          text: mainText,
          textDecorationStyle: mainTextStyle,
          height: 2,
          fontSize: mainTextSize,
          textDecoration: mainTextDecoration ??
              TextDecoration.combine([
//              MdiIcons.android,
//              MdiIcons.snapchat,
                TextDecoration.overline,
                TextDecoration.underline,
              ])),
    ),
    lead: MdiLogo.combineTextShapeSample(
      text: leadText,
      width: 85,
      height: 43,
      textShadows: ShadowAsset.singleShadow(dx: -1, dy: 1.5),
      shapeColor: shapeColor,
      shape: BoxShape.rectangle,
    ),
  );
}

List<Widget> textList() {
  return [
    VSpace(5),
//          MdiLogo.materialDesignLogo(),
    MdiLogo.google(
      plainLogo: true,
      fontSize: 64,
      textAlign: TextAlign.center,
    ),
    MdiLogo.facebook(
      plainLogo: true,
      fontSize: 64,
      textAlign: TextAlign.center,
    ),
    MdiLogo.ebay(
      plainLogo: true,
      fontSize: 64,
      textAlign: TextAlign.center,
    ),
    MdiLogo.linkedln(
      plainLogo: true,
      fontSize: 63,
      textAlign: TextAlign.center,
    ),
    MdiLogo.nestle(
      plainLogo: true,
      textSpans: TextSpanAsset.nestleTexts(),
      textAlign: TextAlign.center,
    ),
    MdiLogo.netflix(textAlign: TextAlign.center),
    VSpace(10),
    MdiLogo.fedX(textAlign: TextAlign.center),
  ];
}

List<Widget> iconScreenWidgets() {
  return [
    VSpace(),
    shapedLogoRow(BoxShape.rectangle),
    VSpace(20),
    shapedLogoRow(BoxShape.circle),
  ];
}

List<Widget> shapedWidgets() {
  return [
    Padding(
      padding: const EdgeInsets.all(8.0),
      child: Row(
        mainAxisAlignment: MainAxisAlignment.center,
        children: [
          MdiLogo.linkedln(
            borderWidth: 2,
            fontSize: 63,
          ),
          HSpace(),
          MdiLogo.facebook(
            borderWidth: 2,
            fontSize: 63,
          ),
          HSpace(),
          MdiLogo.facebook(
            borderWidth: 1,
            borderColor: Colors.blue,
            shapeColor: Colors.white,
            fontColor: Colors.blue,
            fontSize: 63,
          ),
        ],
      ),
    ),
    VSpace(),
    Row(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        MdiLogo.linkedln(
          fontSize: 68,
          logoShape: BoxShape.circle,
        ),
        HSpace(),
        MdiLogo.facebook(
          borderWidth: 2,
          fontSize: 68,
          logoShape: BoxShape.circle,
        ),
        HSpace(),
        MdiLogo.facebook(
          borderWidth: 1,
          borderColor: Colors.blue,
          shapeColor: Colors.white,
          fontColor: Colors.blue,
          shapeShadow: [
            BoxShadow(color: Colors.grey[700], offset: Offset(-1.5, 2)),
          ],
          fontSize: 68,
          logoShape: BoxShape.circle,
        ),
      ],
    ),
    VSpace(),
    Center(
      child: MdiLogo.shapeText(
        shapeColor: Colors.white,
        textSpans: TextSpanAsset.nestleTexts(),
        shapeRadius: BorderRadius.circular(10),
        borderWidth: 2,
        logoShape: BoxShape.rectangle,
      ),
    ),
    VSpace(),
    Row(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        MdiLogo.shapeText(
          shapeColor: Colors.white,
          textSpans: TextSpanAsset.googleTexts(),
          shapeRadius: BorderRadius.circular(10),
          borderWidth: 2,
          fontSize: 63,
          logoShape: BoxShape.rectangle,
        ),
        HSpace(),
        MdiLogo.shapeText(
          shapeColor: Colors.white,
          textSpans: TextSpanAsset.ebayTexts(),
          shapeRadius: BorderRadius.circular(10),
          borderWidth: 2,
          fontSize: 63,
          logoShape: BoxShape.rectangle,
        ),
      ],
    ),
  ];
}

Row shapedLogoRow(BoxShape shape) {
  return Row(
    mainAxisAlignment: MainAxisAlignment.center,
    children: [
      MdiLogo.whatsApp(
        logoShape: shape,
      ),
      HSpace(),
      MdiLogo.twitter(
        logoShape: shape,
      ),
      HSpace(),
      MdiLogo.instagram(
        logoShape: shape,
      ),
      HSpace(),
      MdiLogo.microsoft(
        logoShape: shape,
      ),
      HSpace(),
      MdiLogo.apple(
        logoShape: shape,
      ),
    ],
  );
}

class HSpace extends StatelessWidget {
  final double width;

  const HSpace({
    Key key,
    this.width,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return SizedBox(
      width: width ?? 10,
    );
  }
}

class VSpace extends StatelessWidget {
  final double height;

  const VSpace([this.height]);

  @override
  Widget build(BuildContext context) {
    return SizedBox(
      height: height ?? 10,
    );
  }
}
