library materialdesignlogo;

import 'package:flutter/material.dart';
import 'package:material_design_icons_flutter/material_design_icons_flutter.dart';
import 'package:materialdesignlogo/basic.dart';
import 'package:materialdesignlogo/widget_type.dart';

import 'assets/strings.dart';

class MdiLogo extends StatelessWidget {
  MdiLogo.plainText({
    this.fontSize,
    this.fontColor,
    this.text,
    this.textStyle,
    this.textSpans,
    this.letterSpacing,
    this.fontWeight,
    this.fontStyle,
    this.fontFamily,
    this.padding,
    this.textShadows,
    this.textAlign,
  })  : this.icon = null,
        this.iconColor = null,
        this.iconSize = null,
        logo = PlainText(
            fontSize: fontSize,
            letterSpacing: letterSpacing,
            textShadows: textShadows,
            text: text,
            textStyle: textStyle,
            textAlign: textAlign,
            fontWeight: fontWeight,
            fontFamily: fontFamily,
            fontColor: fontColor,
            fontStyle: fontStyle,
            textSpan: textSpans,
            padding: padding),
        plainLogo = true,
        width = null,
        widget = null,
        height = null,
        fullText = false,
        logoGradient = null,
        logoShape = null,
        decoration = null,
        shapeRadius = null,
        borderColor = null,
        borderWidth = null,
        shapeColor = null,
        shapeShadow = null;

  MdiLogo.shapeText({
    this.height,
    this.width,
    this.fontColor,
    this.logoGradient,
    this.text,
    this.textStyle,
    this.fontWeight,
    this.fontStyle,
    this.fontFamily,
    this.textShadows,
    this.logoShape,
    this.decoration,
    this.shapeRadius,
    this.borderColor,
    this.textSpans,
    this.borderWidth,
    this.shapeShadow,
    this.fontSize,
    this.letterSpacing,
    this.textAlign,
    this.padding,
    this.shapeColor,
  })  : this.icon = null,
        this.iconColor = null,
        this.iconSize = null,
        logo = TextShapeLogo(
          height,
          width,
          decoration,
          logoShape,
          shapeRadius,
          borderColor,
          shapeColor,
          borderWidth,
          logoGradient,
          shapeShadow ??
              [
                BoxShadow(color: Colors.grey[700], offset: Offset(-1.5, 2)),
              ],
          PlainText(
              fontSize: fontSize,
              letterSpacing: letterSpacing,
              textShadows: textShadows,
              text: text,
              textStyle: textStyle,
              textAlign: textAlign,
              fontWeight: fontWeight,
              fontFamily: fontFamily,
              fontColor: fontColor,
              fontStyle: fontStyle,
              textSpan: textSpans,
              padding: padding),
        ),
        widget = null,
        fullText = false,
        plainLogo = false;

  MdiLogo.shapeWidget({
    this.height,
    this.width,
    this.logoGradient,
    this.logoShape: BoxShape.circle,
    this.decoration,
    this.shapeRadius,
    this.borderColor,
    this.borderWidth,
    this.shapeShadow,
    this.padding,
    this.widget,
    this.shapeColor,
  })  : logo = WidgetShapeLogo(
            widget,
            height,
            width,
            padding,
            decoration,
            shapeRadius ?? BorderRadius.circular(5),
            borderColor,
            shapeColor,
            borderWidth,
            logoGradient,
            shapeShadow ?? ShadowAsset.singleShadow(),
            logoShape),
        plainLogo = false,
        text = null,
        this.icon = null,
        this.iconColor = null,
        this.iconSize = null,
        this.textSpans = null,
        this.textStyle = null,
        this.fontWeight = null,
        this.fontStyle = null,
        this.fullText = false,
        this.fontFamily = null,
        this.textShadows = null,
        this.fontSize = null,
        this.letterSpacing = null,
        this.textAlign = null,
        fontColor = null;

  MdiLogo.shapeIcon({
    this.logoGradient,
    this.logoShape,
    this.decoration,
    this.shapeRadius,
    this.borderColor,
    this.borderWidth,
    this.shapeShadow,
    this.padding,
    this.shapeColor,
    this.icon,
    this.iconColor,
    this.iconSize,
  })  : logo = IconShapeLogo(
            icon: icon ?? MdiIcons.whatsapp,
            iconColor: iconColor,
            iconSize: iconSize,
            padding: padding,
            decoration: decoration,
            shapeRadius: shapeRadius ?? BorderRadius.circular(10),
            borderColor: borderColor,
            shapeColor: shapeColor,
            borderWidth: borderWidth,
            shapeGradient: logoGradient,
            shapeShadow: shapeShadow ??
                [
                  BoxShadow(color: Colors.grey[700], offset: Offset(-1.5, 2)),
                ],
            shape: logoShape),
        plainLogo = false,
        text = null,
        this.textSpans = null,
        this.textStyle = null,
        this.width = null,
        this.height = null,
        this.fontWeight = null,
        this.widget = null,
        this.fontStyle = null,
        this.fullText = false,
        this.fontFamily = null,
        this.textShadows = null,
        this.fontSize = null,
        this.letterSpacing = null,
        this.textAlign = null,
        fontColor = null;

  static MdiLogo facebook({
    text,
    textStyle,
    textSpans,
    plainLogo: false,
    height,
    width,
    fontSize,
    fontColor,
    logoGradient,
    letterSpacing,
    fontWeight,
    fontStyle,
    fontFamily,
    textShadows,
    logoShape: BoxShape.rectangle,
    decoration,
    shapeRadius,
    fullText: false,
    borderColor,
    borderWidth,
    shapeShadow,
    textAlign,
    padding,
    shapeColor,
  }) =>
      plainLogo
          ? MdiLogo.plainText(
              fontSize: fontSize,
              fontColor: fontColor,
              text: text ?? TextAsset.fbLong,
              textStyle: textStyle,
              textSpans: textSpans,
              letterSpacing: letterSpacing,
              fontWeight: fontWeight,
              fontStyle: fontStyle,
              fontFamily: fontFamily,
              padding: padding,
              textShadows: textShadows ?? ShadowAsset.singleShadow(),
              textAlign: textAlign,
            )
          : MdiLogo.shapeText(
              height: height,
              width: width,
              fontColor: fontColor,
              logoGradient: logoGradient,
              textStyle: textStyle,
              fontWeight: fontWeight,
              fontStyle: fontStyle,
              fontFamily: fontFamily,
              textShadows: textShadows,
              logoShape: logoShape,
              decoration: decoration,
              shapeRadius: shapeRadius ?? BorderRadius.circular(10),
              borderColor: borderColor,
              textSpans: textSpans,
              borderWidth: borderWidth,
              shapeShadow: textShadows ?? ShadowAsset.singleShadow(),
              text: text ??
                  (isCircle(logoShape) || !fullText
                      ? TextAsset.fbShort
                      : TextAsset.fbLong),
              fontSize: fontSize,
              letterSpacing: letterSpacing,
              textAlign: textAlign,
              padding: padding,
              shapeColor: shapeColor,
            );

  static MdiLogo fedX({
    fontSize,
    fontColor,
    text,
    textStyle,
    textSpans,
    letterSpacing,
    fontWeight,
    fontStyle,
    fontFamily,
    padding,
    textShadows,
    textAlign,
  }) =>
      MdiLogo.plainText(
        fontSize: fontSize,
        fontColor: fontColor,
        text: text,
        textStyle: textStyle,
        textSpans: textSpans ?? TextSpanAsset.fedX(),
        letterSpacing: letterSpacing,
        fontWeight: fontWeight,
        fontStyle: fontStyle,
        fontFamily: fontFamily,
        padding: padding,
        textShadows: textShadows ?? ShadowAsset.singleShadow(),
        textAlign: textAlign,
      );

  static MdiLogo netflix({
    fontSize,
    fontColor,
    text,
    textStyle,
    textSpans,
    letterSpacing,
    fontWeight,
    fontStyle,
    fontFamily,
    padding,
    textShadows,
    textAlign,
  }) =>
      MdiLogo.plainText(
        fontSize: fontSize,
        fontColor: fontColor,
        text: text,
        textStyle: textStyle,
        textSpans: textSpans ?? TextSpanAsset.netflix(),
        letterSpacing: letterSpacing,
        fontWeight: fontWeight,
        fontStyle: fontStyle,
        fontFamily: fontFamily,
        padding: padding,
        textShadows: textShadows ?? ShadowAsset.singleShadow(),
        textAlign: textAlign,
      );

  static MdiLogo linkedln({
    text,
    textStyle,
    textSpans,
    plainLogo: false,
    height,
    width,
    fontSize,
    fontColor,
    logoGradient,
    letterSpacing,
    fontWeight,
    fullText: false,
    fontStyle,
    fontFamily,
    textShadows,
    logoShape: BoxShape.rectangle,
    decoration,
    shapeRadius,
    borderColor,
    borderWidth,
    shapeShadow,
    textAlign,
    padding,
    shapeColor,
  }) =>
      plainLogo
          ? MdiLogo.plainText(
              fontSize: fontSize,
              fontColor: fontColor,
              text: text ?? TextAsset.linkedlnLong,
              textStyle: textStyle,
              textSpans: textSpans,
              letterSpacing: letterSpacing,
              fontWeight: fontWeight,
              fontStyle: fontStyle,
              fontFamily: fontFamily,
              padding: padding,
              textShadows: textShadows ?? ShadowAsset.singleShadow(),
              textAlign: textAlign,
            )
          : MdiLogo.shapeText(
              height: height,
              width: width,
              fontColor: fontColor,
              logoGradient: logoGradient,
              textStyle: textStyle,
              fontWeight: fontWeight,
              fontStyle: fontStyle,
              fontFamily: fontFamily,
              textShadows: textShadows,
              logoShape: logoShape,
              decoration: decoration,
              shapeRadius: shapeRadius ?? BorderRadius.circular(10),
              borderColor: borderColor,
              textSpans: textSpans,
              borderWidth: borderWidth,
              shapeShadow: textShadows ?? ShadowAsset.singleShadow(),
              text: text ??
                  (isCircle(logoShape) || !fullText
                      ? TextAsset.linkedlnShort
                      : TextAsset.linkedlnLong),
              fontSize: fontSize,
              letterSpacing: letterSpacing,
              textAlign: textAlign,
              padding: padding,
              shapeColor: shapeColor,
            );

  static MdiLogo google({
    text,
    textStyle,
    textSpans,
    plainLogo: false,
    height,
    width,
    fontSize,
    fontColor,
    logoGradient,
    letterSpacing,
    fontWeight,
    fullText: false,
    fontStyle,
    fontFamily,
    textShadows,
    logoShape: BoxShape.circle,
    decoration,
    shapeRadius,
    borderColor,
    borderWidth,
    shapeShadow,
    textAlign,
    padding,
    shapeColor,
  }) =>
      plainLogo
          ? MdiLogo.plainText(
              fontSize: fontSize,
              fontColor: fontColor,
              text: text,
              textStyle: textStyle,
              textSpans: textSpans ?? TextSpanAsset.googleTexts(),
              letterSpacing: letterSpacing,
              fontWeight: fontWeight,
              fontStyle: fontStyle,
              fontFamily: fontFamily,
              padding: padding,
              textShadows: textShadows ?? ShadowAsset.singleShadow(),
              textAlign: textAlign,
            )
          : MdiLogo.shapeText(
              height: height,
              width: width,
              fontColor: fontColor,
              logoGradient: logoGradient,
              textStyle: textStyle,
              fontWeight: fontWeight,
              fontStyle: fontStyle,
              fontFamily: fontFamily,
              textShadows: textShadows,
              logoShape: logoShape,
              decoration: decoration,
              shapeRadius: shapeRadius,
              borderColor: borderColor,
              textSpans: textSpans,
              borderWidth: borderWidth,
              shapeShadow: textShadows ?? ShadowAsset.singleShadow(),
              text: text ?? TextAsset.googleShort,
              fontSize: fontSize,
              letterSpacing: letterSpacing,
              textAlign: textAlign,
              padding: padding,
              shapeColor: shapeColor,
            );

  static MdiLogo nestle({
    text,
    textStyle,
    textSpans,
    plainLogo: false,
    height,
    width,
    fontSize,
    fontColor,
    logoGradient,
    letterSpacing,
    fontWeight,
    fullText: false,
    fontStyle,
    fontFamily,
    textShadows,
    logoShape,
    decoration,
    shapeRadius,
    borderColor,
    borderWidth,
    shapeShadow,
    textAlign,
    padding,
    shapeColor,
  }) =>
      MdiLogo.plainText(
        fontSize: fontSize,
        fontColor: fontColor,
        text: text,
        textStyle: textStyle,
        textSpans: textSpans ?? TextSpanAsset.nestleTexts(),
        letterSpacing: letterSpacing,
        fontWeight: fontWeight,
        fontStyle: fontStyle,
        fontFamily: fontFamily,
        padding: padding,
        textShadows: textShadows ?? ShadowAsset.singleShadow(),
        textAlign: textAlign,
      );

  static MdiLogo cocacola({
    text,
    textStyle,
    textSpans,
    plainLogo: false,
    height,
    width,
    fontSize,
    fontColor,
    logoGradient,
    letterSpacing,
    fontWeight,
    fullText: false,
    fontStyle,
    fontFamily,
    textShadows,
    logoShape,
    decoration,
    shapeRadius,
    borderColor,
    borderWidth,
    shapeShadow,
    textAlign,
    padding,
    shapeColor,
  }) =>
      MdiLogo.plainText(
        fontSize: fontSize,
        fontColor: fontColor,
        text: text ?? 'Coca.Cola',
        textStyle: textStyle,
        textSpans: textSpans,
        letterSpacing: letterSpacing,
        fontWeight: fontWeight,
        fontStyle: fontStyle,
        fontFamily: fontFamily ?? 'cocacola',
        padding: padding,
        textShadows: textShadows ?? ShadowAsset.singleShadow(),
        textAlign: textAlign,
      );

  static MdiLogo ebay({
    text,
    textStyle,
    textSpans,
    plainLogo: false,
    height,
    width,
    fontSize,
    fontColor,
    logoGradient,
    letterSpacing,
    fontWeight,
    fullText: false,
    fontStyle,
    fontFamily,
    textShadows,
    logoShape: BoxShape.circle,
    decoration,
    shapeRadius,
    borderColor,
    borderWidth,
    shapeShadow,
    textAlign,
    padding,
    shapeColor,
  }) =>
      plainLogo
          ? MdiLogo.plainText(
              fontSize: fontSize,
              fontColor: fontColor,
              text: text,
              textStyle: textStyle,
              textSpans: textSpans ?? TextSpanAsset.ebayTexts(),
              letterSpacing: letterSpacing ?? -7,
              fontWeight: fontWeight,
              fontStyle: fontStyle,
              fontFamily: fontFamily,
              padding: padding,
              textShadows: textShadows ?? ShadowAsset.singleShadow(),
              textAlign: textAlign,
            )
          : MdiLogo.shapeText(
              height: height,
              width: width,
              fontColor: fontColor,
              logoGradient: logoGradient,
              textStyle: textStyle,
              fontWeight: fontWeight,
              fontStyle: fontStyle,
              fontFamily: fontFamily,
              textShadows: textShadows,
              logoShape: logoShape,
              decoration: decoration,
              shapeRadius: shapeRadius,
              borderColor: borderColor,
              textSpans: textSpans,
              borderWidth: borderWidth,
              shapeShadow: textShadows ?? ShadowAsset.singleShadow(),
              text: text ?? "e",
              fontSize: fontSize,
              letterSpacing: letterSpacing,
              textAlign: textAlign,
              padding: padding,
              shapeColor: shapeColor,
            );

  static Widget autoShapeText<T>({
    String text: 'BBC',
    Map<T, TextStyle> textStyle,
    Map<T, double> height,
    Map<T, double> width,
    Map<T, double> fontSize,
    Map<T, Color> fontColor,
    Map<T, Gradient> logoGradient,
    Map<T, double> letterSpacing,
    Map<T, FontWeight> fontWeight,
    Map<T, FontStyle> fontStyle,
    Map<T, String> fontFamily,
    Map<T, List<Shadow>> textShadows,
    Map<T, BoxShape> logoShape,
    Map<T, BoxDecoration> decoration,
    Map<T, BorderRadius> shapeRadius,
    Map<T, Color> borderColor,
    Map<T, double> borderWidth,
    Map<T, List<BoxShadow>> shapeShadow,
    Map<T, Color> shapeColor,
  }) {
    letterSpacing = letterSpacing.splitKeys;
    height = height.splitKeys;
    width = width.splitKeys;
    textStyle = textStyle.splitKeys;
    fontSize = fontSize.splitKeys;
    fontColor = fontColor.splitKeys;
    logoGradient = logoGradient.splitKeys;
    fontWeight = fontWeight.splitKeys;
    fontStyle = fontStyle.splitKeys;
    fontFamily = fontFamily.splitKeys;
    textShadows = textShadows.splitKeys;
    logoShape = logoShape.splitKeys;
    decoration = decoration.splitKeys;
    shapeRadius = shapeRadius.splitKeys;
    borderColor = borderColor.splitKeys;
    borderWidth = borderWidth.splitKeys;
    shapeShadow = shapeShadow.splitKeys;
    shapeColor = shapeColor.splitKeys;
    return Wrap(
      alignment: WrapAlignment.center,
//      mainAxisAlignment: MainAxisAlignment.center,
//      mainAxisSize: MainAxisSize.min,
      children: [
        for (int i = 0; i < text.length; i++)
          Padding(
            padding:
                EdgeInsets.symmetric(horizontal: letterSpacing[text[i]] ?? 2.0),
            child: MdiLogo.shapeText(
              height: height[T is int ? i : text[i]],
              width: width[text[i]],
              fontColor: fontColor[text[i]],
              logoGradient: logoGradient[text[i]],
              textStyle: textStyle[text[i]],
              fontWeight: fontWeight[text[i]],
              fontStyle: fontStyle[text[i]],
              fontFamily: fontFamily[text[i]],
              textShadows: textShadows[text[i]],
              logoShape: logoShape[text[i]] ?? BoxShape.rectangle,
              decoration: decoration[text[i]],
              shapeRadius: shapeRadius[text[i]],
              borderColor: borderColor[text[i]],
              borderWidth: borderWidth[text[i]],
              shapeShadow: shapeShadow[text[i]] ?? ShadowAsset.singleShadow(),
              text: text[i],
              fontSize:
                  fontSize[T == int?i:text[i]/* text.indexOrAlphabet(i, T)*/],
              shapeColor: shapeColor[text[i]] ?? Colors.grey[800],
            ),
          ),
      ],
    );
  }

  static MdiLogo whatsApp({
    plainLogo: false,
    logoGradient,
    logoShape: BoxShape.rectangle,
    decoration,
    shapeRadius,
    borderColor: Colors.white,
    borderWidth: 2,
    shapeShadow,
    textAlign,
    padding,
    shapeColor: Colors.green,
    icon,
    iconColor,
    iconSize,
  }) =>
      MdiLogo.shapeIcon(
        logoGradient: logoGradient,
        logoShape: logoShape,
        decoration: decoration,
        shapeRadius: shapeRadius,
        borderColor: borderColor,
        borderWidth: borderWidth,
        shapeShadow: shapeShadow,
        padding: padding,
        shapeColor: shapeColor,
        icon: icon ?? MdiIcons.whatsapp,
        iconColor: iconColor,
        iconSize: iconSize,
      );

  static MdiLogo instagram({
    plainLogo: false,
    logoGradient,
    logoShape: BoxShape.rectangle,
    decoration,
    shapeRadius,
    borderColor: Colors.white,
    borderWidth: 2,
    shapeShadow,
    textAlign,
    padding,
    shapeColor: Colors.pinkAccent,
    icon,
    iconColor,
    iconSize,
  }) =>
      MdiLogo.shapeIcon(
        logoGradient: logoGradient,
        logoShape: logoShape,
        decoration: decoration,
        shapeRadius: shapeRadius,
        borderColor: borderColor,
        borderWidth: borderWidth,
        shapeShadow: shapeShadow,
        padding: padding,
        shapeColor: shapeColor,
        icon: icon ?? MdiIcons.instagram,
        iconColor: iconColor,
        iconSize: iconSize,
      );

  static MdiLogo twitter(
          {plainLogo: false,
          logoGradient,
          logoShape: BoxShape.rectangle,
          decoration,
          shapeRadius,
          borderColor: Colors.white,
          borderWidth: 2,
          shapeShadow,
          textAlign,
          padding,
          shapeColor: Colors.blueAccent,
          icon,
          iconColor,
          iconSize}) =>
      MdiLogo.shapeIcon(
        logoGradient: logoGradient,
        logoShape: logoShape,
        decoration: decoration,
        shapeRadius: shapeRadius,
        borderColor: borderColor,
        borderWidth: borderWidth,
        shapeShadow: shapeShadow,
        padding: padding,
        shapeColor: shapeColor,
        icon: icon ?? MdiIcons.twitter,
        iconColor: iconColor,
        iconSize: iconSize,
      );

  static MdiLogo microsoft(
          {plainLogo: false,
          logoGradient,
          logoShape: BoxShape.rectangle,
          decoration,
          shapeRadius,
          borderColor: Colors.white,
          borderWidth: 2,
          shapeShadow,
          textAlign,
          padding,
          shapeColor: Colors.blueAccent,
          icon,
          iconColor,
          iconSize}) =>
      MdiLogo.shapeIcon(
        logoGradient: logoGradient,
        logoShape: logoShape,
        decoration: decoration,
        shapeRadius: shapeRadius,
        borderColor: borderColor,
        borderWidth: borderWidth,
        shapeShadow: shapeShadow,
        padding: padding,
        shapeColor: shapeColor,
        icon: icon ?? MdiIcons.microsoftWindowsClassic,
        iconColor: iconColor,
        iconSize: iconSize,
      );

  static MdiLogo apple(
          {plainLogo: false,
          logoGradient,
          logoShape: BoxShape.rectangle,
          decoration,
          shapeRadius,
          borderColor: Colors.white,
          borderWidth: 2,
          shapeShadow,
          textAlign,
          padding,
          shapeColor: Colors.black,
          widget,
          icon,
          iconColor,
          iconSize}) =>
      MdiLogo.shapeIcon(
        logoGradient: logoGradient,
        logoShape: logoShape,
        decoration: decoration,
        shapeRadius: shapeRadius,
        borderColor: borderColor,
        borderWidth: borderWidth,
        shapeShadow: shapeShadow,
        padding: padding,
        shapeColor: shapeColor,
        icon: icon ?? MdiIcons.apple,
        iconColor: iconColor,
        iconSize: iconSize,
      );

  static MdiLogo oralB(
          {plainLogo: false,
          logoGradient,
          logoShape: BoxShape.rectangle,
          decoration,
          shapeRadius,
          borderColor: Colors.white,
          borderWidth: 2,
          shapeShadow,
          textAlign,
          padding,
          shapeColor: Colors.black,
          widget,
          icon,
          iconColor,
          iconSize}) =>
      MdiLogo.shapeIcon(
        logoGradient: logoGradient,
        logoShape: logoShape,
        decoration: decoration,
        shapeRadius: shapeRadius,
        borderColor: borderColor,
        borderWidth: borderWidth,
        shapeShadow: shapeShadow,
        padding: padding,
        shapeColor: shapeColor,
        icon: icon ?? MdiIcons.apple,
        iconColor: iconColor,
        iconSize: iconSize,
      );

  static Widget combinedLogo({
    LeadGravity leadGravity,
    EdgeInsetsGeometry padding,
    Widget lead,
    Widget content,
    double gap,
    MainAxisAlignment mainAxisAlignment = MainAxisAlignment.center,
  }) =>
      CombinedLogo(
        leadGravity,
        padding,
        lead,
        content,
        gap: gap,
        mainAxisAlignment: mainAxisAlignment,
      );

  static Widget microsoftXBox(
          {MdiLogo content,
          MdiLogo lead,
          double gap,
          MainAxisAlignment mainAxisAlignment,
          LeadGravity leadGravity,
          EdgeInsetsGeometry padding}) =>
      MdiLogo.combinedLogo(
        mainAxisAlignment: mainAxisAlignment ?? MainAxisAlignment.center,
        gap: gap,
        leadGravity: LeadGravity.start,
        content: content ??
            MdiLogo.plainText(
                fontFamily: 'x360',
                text: TextAsset.xBox,
                fontSize: 43,
                textShadows: ShadowAsset.singleShadow(
                    shadowColor: Colors.grey[700], dx: -1, dy: 1.4),
                fontWeight: FontWeight.w400,
                fontColor: Colors.green),
        lead: lead ??
            MdiLogo.shapeIcon(
              icon: MdiIcons.microsoftXbox,
              iconColor: Colors.white,
              shapeColor: Colors.green,
            ),
      );

  static Widget microsoftCombined(
          {MdiLogo content,
          MdiLogo lead,
          double gap,
          MainAxisAlignment mainAxisAlignment,
          LeadGravity leadGravity,
          EdgeInsetsGeometry padding}) =>
      MdiLogo.combinedLogo(
        mainAxisAlignment: mainAxisAlignment ?? MainAxisAlignment.center,
        gap: gap,
        leadGravity: LeadGravity.start,
        content: content ??
            MdiLogo.plainText(
                fontSize: 30,
                textShadows: ShadowAsset.singleShadow(
                    shadowColor: Colors.grey[700], dx: -1, dy: 1),
                text: TextAsset.microsoft,
                fontColor: Colors.green),
        lead: lead ??
            MdiLogo.shapeIcon(
              icon: MdiIcons.microsoftWindowsClassic,
              iconColor: Colors.green,
              shapeColor: Colors.white,
            ),
      );

  static Widget adobe(
          {MdiLogo content,
          MdiLogo lead,
          double gap,
          MainAxisAlignment mainAxisAlignment,
          LeadGravity leadGravity,
          EdgeInsetsGeometry padding}) =>
      MdiLogo.combinedLogo(
        mainAxisAlignment: mainAxisAlignment ?? MainAxisAlignment.center,
        gap: gap,
        leadGravity: LeadGravity.top,
        content: content ??
            MdiLogo.plainText(text: TextAsset.adobe, fontColor: Colors.black),
        lead: lead ??
            MdiLogo.shapeIcon(
              icon: MdiIcons.adobe,
              iconColor: Colors.red,
              shapeColor: Colors.white,
              iconSize: 53,
            ),
      );

  static Widget android(
          {MdiLogo content,
          MdiLogo lead,
          double gap,
          MainAxisAlignment mainAxisAlignment,
          LeadGravity leadGravity,
          EdgeInsetsGeometry padding}) =>
      MdiLogo.combinedLogo(
        mainAxisAlignment: mainAxisAlignment ?? MainAxisAlignment.center,
        gap: gap ?? 0,
        leadGravity: LeadGravity.top,
        content: content ??
            MdiLogo.plainText(
              text: TextAsset.android,
              fontColor: Colors.black,
              fontFamily: 'x360',
            ),
        lead: lead ??
            Icon(
              MdiIcons.android,
              color: Colors.green,
              size: 53,
            ),
      );

  static Widget mdiLogo(
          {MdiLogo content,
          MdiLogo lead,
          double gap,
          MainAxisAlignment mainAxisAlignment,
          LeadGravity leadGravity,
          EdgeInsetsGeometry padding}) =>
      MdiLogo.combinedLogo(
        mainAxisAlignment: mainAxisAlignment ?? MainAxisAlignment.start,
        gap: gap,
        leadGravity: leadGravity ?? LeadGravity.start,
        content: content ??
            MdiLogo.plainText(
              textAlign: TextAlign.start,
              textSpans: TextSpanAsset.mdiLogoTexts(),
            ),
        lead: lead ??
            MdiLogo.shapeIcon(
              icon: MdiIcons.materialDesign,
              shapeColor: Colors.pink,
              borderWidth: 1,
              logoShape: BoxShape.rectangle,
              shapeRadius: BorderRadius.circular(8),
              shapeShadow: [
                BoxShadow(color: Colors.grey[700], offset: Offset(-1.5, 2)),
              ],
            ),
      );

  static Widget linkedlnCombine(
          {MdiLogo content,
          MdiLogo lead,
          MainAxisAlignment mainAxisAlignment,
          LeadGravity leadGravity,
          double gap,
          EdgeInsetsGeometry padding}) =>
      MdiLogo.combinedLogo(
        mainAxisAlignment: mainAxisAlignment ?? MainAxisAlignment.center,
        gap: gap,
        leadGravity: leadGravity ?? LeadGravity.end,
        content: content ??
            MdiLogo.linkedln(plainLogo: true, fontColor: Colors.black),
        lead: lead ?? MdiLogo.linkedln(plainLogo: false, borderWidth: 2),
      );

  static Widget instagramCombine(
          {MdiLogo content,
          MdiLogo lead,
          double gap,
          MainAxisAlignment mainAxisAlignment,
          LeadGravity leadGravity,
          EdgeInsetsGeometry padding}) =>
      MdiLogo.combinedLogo(
        gap: gap,
        leadGravity: leadGravity ?? LeadGravity.start,
        content: content ??
            MdiLogo.plainText(
              fontColor: Colors.black,
              fontWeight: FontWeight.w200,
              fontSize: 43,
//              fontFamily: 'bebas-neue',
              fontStyle: FontStyle.normal,
              text: "Instagram",
              textShadows: ShadowAsset.singleShadow(),
              textAlign: TextAlign.center,
            ),
        lead: lead ?? MdiLogo.instagram(),
      );

  static Widget combineMdiSample(
          {MdiLogo content,
          MdiLogo lead,
          double gap,
          MainAxisAlignment mainAxisAlignment,
          LeadGravity leadGravity,
          EdgeInsetsGeometry padding}) =>
      MdiLogo.combinedLogo(
        mainAxisAlignment: mainAxisAlignment ?? MainAxisAlignment.center,
        gap: gap,
        leadGravity: LeadGravity.start,
        content: Padding(
          padding: const EdgeInsets.only(top: 8.0),
          child: content ??
              combinePlainTextSample(
                decorationThickness: 1.2,
              ),
        ),
        lead: lead ?? combineTextShapeSample(),
      );

  static MdiLogo combinePlainTextSample({
    text: 'Design',
    List<Shadow> textShadows,
    fontSize: 28.0,
    height: 2.0,
    letterSpacing: -2,
    fontFamily: 'JosefinSans',
    fontWeight: FontWeight.w300,
    fontColor: Colors.white30,
    textDecorationStyle: TextDecorationStyle.double,
    decorationThickness: 1.0,
    textDecoration: TextDecoration.underline,
  }) {
    return MdiLogo.plainText(
      text: text,
      textStyle: TextStyle(
        height: height,
        fontSize: fontSize,
        letterSpacing: letterSpacing,
        fontFamily: fontFamily,
        decoration: textDecoration,
        shadows:
            textShadows ?? ShadowAsset.singleShadow(shadowColor: Colors.black),
        decorationThickness: decorationThickness,
        fontWeight: fontWeight,
        decorationStyle: textDecorationStyle,
        color: fontColor,
      ),
    );
  }

  static MdiLogo combineTextShapeSample(
      {height,
      width,
      padding,
      shapeShadow,
      fontSize,
      letterSpacing,
      fontFamily,
      text,
      fontWeight,
      fontColor,
      shapeColor,
      List<Shadow> textShadows,
      shape}) {
    var logoShape = shape ?? BoxShape.circle;
    var isCircleShape = logoShape == BoxShape.circle;
    return MdiLogo.shapeWidget(
      padding: padding ?? EdgeInsets.only(top: 8, left: 6),
      width: width ?? (isCircleShape ? null : 100),
      height: height ?? (isCircleShape ? null : 50),
      shapeShadow: shapeShadow ??
          ShadowAsset.singleShadow(dx: -1, dy: 2, shadowColor: Colors.black26),
      widget: MdiLogo.plainText(
          textShadows: textShadows,
          fontSize: fontSize ?? isCircleShape ? 30 : 36,
          letterSpacing: letterSpacing ?? -1.2,
          fontFamily: fontFamily ?? 'Marvel',
          text: text ?? (isCircleShape ? 'LOGO' : 'MdiLOGO'),
          fontWeight: fontWeight ?? FontWeight.w200,
          fontColor: fontColor ?? Colors.white),
      shapeColor: shapeColor ?? Colors.red,
      logoShape: logoShape,
    );
  }

  final LogoProvider logo;
  final String text;
  final TextStyle textStyle;
  final List<InlineSpan> textSpans;
  final bool plainLogo;
  final double height;
  final double width;
  final double fontSize;
  final Color fontColor;
  final Gradient logoGradient;
  final double letterSpacing;
  final FontWeight fontWeight;
  final FontStyle fontStyle;
  final String fontFamily;
  final List<Shadow> textShadows;
  final BoxShape logoShape;
  final Decoration decoration;
  final BorderRadiusGeometry shapeRadius;
  final Color borderColor;
  final Color shapeColor;
  final double borderWidth;
  final List<BoxShadow> shapeShadow;
  final TextAlign textAlign;
  final EdgeInsetsGeometry padding;
  final Widget widget;
  final bool fullText;
  final IconData icon;
  final Color iconColor;
  final double iconSize;

  static bool isCircle(BoxShape logoShape) => logoShape == BoxShape.circle;

  @override
  Widget build(BuildContext context) {
    return logo is ShapeLogo
        ? (logo as ShapeLogo).shapedWidget()
        : (logo.alignment() == TextAlign.center
            ? Center(child: logo.child())
            : logo.child());
  }
}

extension AutoShapeExt1<T> on Map<String, T> {
  T operator [](String key) {
    if (this != null) {
      return this[key];
    } else {
      return {"": null}[key];
    }
  }
}

extension AutoShapeAddAll<V, T> on Map<V, T> {
//  Map<String, T> operator &(Map<String, T> otherMap) {
//    this.addAll(otherMap);
//    return this;
//  }

  Map<V, T> get splitKeys {
    Map<V, T> result = {};
    if (this != null) {
      for (V mapKey in this.keys) {
        var length = (mapKey is String) ? mapKey.length : 1;
        if (length > 1) {
          for (var i = 0; i < length; i++) {
            String letter = (mapKey as String)[i];
            (result as Map<String, T>)[letter] = this[mapKey];
            print("the map of key $letter is ${result[letter]}");
          }
        } else {
          result[mapKey] = this[mapKey];
        }
      }
    }
    return result;
  }
}

extension AutoShapeExt2<T> on String {
  indexOrAlphabet(int i, T) {
    if (T == int)
      return i;
    else
      return this[i];
  }
}
